diff --git a/src/util/uevent.c b/src/util/uevent.c
index 1d0d11e..7a37453 100644
--- a/src/util/uevent.c
+++ b/src/util/uevent.c
@@ -157,7 +157,10 @@ void uevent_handler()
 
     struct uevent *ev = uevent_new(buf, len);
     if (ev) {
-        for (GList *l = notifiers; l; l = l->next) {
+        /* we might remove elements in the callback so a copy is needed */
+        GList *list = g_list_copy(notifiers);
+
+        for (GList *l = list; l; l = l->next) {
             struct uevent_notify *nb = l->data;
 
             if (!(ev->action & nb->action))
@@ -169,6 +172,7 @@ void uevent_handler()
             nb->cb(ev, nb->userdata);
         }
 
+        g_list_free(list);
         uevent_free(ev);
     }
 }
